/* Problem URL: https://codeforces.com/problemset/problem/2128/E1 */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    ordered_set<pair<int, int>> ord;

    int n, k;
    cin >> n >> k;
    vi p(n);
    cin >> p;

    int ans = -1;
    int al = -1;
    int ar = -1;
    auto getans = [&](int l, int r, int med) {
        if (med > ans) {
            ans = med;
            al = l;
            ar = r;
        }
    };

    int low = 1;
    int high = n;
    while (low <= high) {
        int mid = (low + high) >> 1;

        vi big(n);
        rep(i, n) {
            big[i] = (p[i] >= mid) - (p[i] < mid);
        }

        vl sum(n + 1);

        nrep(i, 1, k + 1) {
            sum[i] = sum[i - 1] + big[i - 1];
        }

        int tl = 1;
        int ttl = 1;
        int tr = k;

        ll cur = sum[k];
        ll act = cur;
        ll mi = 0;
        nrep(i, k + 1, n + 1) {
            cur += big[i - 1];
            if (mi > sum[i - k]) {
                mi = sum[i - k];
                tl = i - k + 1;
            }
            if (act < cur - mi) {
                act = cur - mi;
                tr = i;
                ttl = tl;
            }
            sum[i] = cur;
        }

        if (act >= 0) {
            ans = mid;
            al = ttl;
            ar = tr;
            low = mid + 1;
            continue;
        }

        high = mid - 1;
    }

    cout << ans << ' ' << al << ' ' << ar << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
